/*
 * Created on Jun 14, 2004
 *
 */
import kareltherobot.*;

/**
 * @author jbergin
 *
 */
public interface JumpStrategy
{
    public void jump(UrRobot who);
    
    public static final JumpStrategy SimplePick = new JumpStrategy()
    {
      public void jump(UrRobot who)
      {
          who.pickBeeper();
          who.putBeeper();
      }
    };
    
    static class MemoryWidget
    {
        public void unwind(UrRobot who)
        {
            who.turnLeft();
            who.turnLeft();
            myStrategy.doIt(who);
            who.turnLeft();
            who.turnLeft();
        }
        
        public void remember()
        {
            myStrategy = new Strategy.MoveWrapper(myStrategy);
        }
        
        private Strategy myStrategy = Strategy.doNothing;
    }
    
    interface Strategy
    {
        public void doIt(UrRobot who);
        
        public static final Strategy doNothing = new Strategy()
        {
            public void doIt(UrRobot who) {}
        };
        
        class MoveWrapper implements Strategy
        {
            public MoveWrapper(Strategy wrapped)
            { this.wrapped = wrapped;
            }
            public void doIt(UrRobot who)
            {
                who.move();
                wrapped.doIt(who);
            }
            Strategy wrapped = null;
        }
    }
}
